MODULE test;

IMPORT SYSTEM,
       Storage,
       SKVideo,
       SKTime,
       VideoBase;

TYPE DragonPtr = POINTER TO Dragon;
     Dragon = RECORD
     	  position : SKVideo.Rect;
     	  source   : SKVideo.Rect;
     	  surface  : SKVideo.SurfacePtr;
     END;

VAR  screen           : SKVideo.SurfacePtr;
     colorKey         : SYSTEM.CARDINAL32;
     walkingTimer     : SKTime.TimerID;
     animationTimer   : SKTime.TimerID;
     dragon           : Dragon;

PROCEDURE Walk(interval : SYSTEM.CARDINAL32; dragon : DragonPtr) : SYSTEM.CARDINAL32;
BEGIN
     IF dragon^.position.x <= (320 - 32) THEN
     	  INC(dragon^.position.x);
     END;
RETURN interval;
END Walk;

PROCEDURE Animate(interval : SYSTEM.CARDINAL32; dragon: DragonPtr) : SYSTEM.CARDINAL32;
BEGIN
     IF dragon^.source.x = 1 THEN
     	  dragon^.source.x := 34;
     ELSE
     	  dragon^.source.x := 1;
     END;
RETURN interval;
END Animate;

BEGIN
     screen := SKVideo.SetVideoMode(320, 200, 16, SKVideo.HwSurface);

     dragon.surface := SKVideo.LoadDisplayFormatedBMP('test.bmp');

     colorKey := SKVideo.MapRGB(dragon.surface^.format, 255, 0, 255);
     SKVideo.SetColorKey(dragon.surface, SKVideo.SrcColorKey + SKVideo.RLEAccel, colorKey);

     walkingTimer := SKTime.AddTimer(20, Walk, SYSTEM.ADR(dragon));
     animationTimer := SKTime.AddTimer(200, Animate, SYSTEM.ADR(dragon));

     dragon.position := SKVideo.Rect{0, 0, 0, 0};
     dragon.source := SKVideo.Rect{34, 1, 32, 32};

     WHILE 1 DO
     	  SKVideo.BlitSurface(dragon.surface, dragon.source, screen, dragon.position);
     	  SKVideo.Flip(screen);
    	  SKVideo.FillRect(screen, screen^.clipRect, 0); 
     END;

     SKTime.RemoveTimer(walkingTimer);
     SKTime.RemoveTimer(animationTimer);
     SKVideo.FreeSurface(dragon.surface);
END test.
