IMPLEMENTATION MODULE SKGeneral;

IMPORT GeneralBase,
       EXCEPTIONS,
       DynamicStrings;

VAR exSrc  : EXCEPTIONS.ExceptionSource;

PROCEDURE Raise();
VAR cString : SYSTEM.ADDRESS;
    dString : DynamicStrings.String;
    string  : ARRAY[0..255] OF CHAR;
BEGIN
     cString := GeneralBase.SDL_GetError();
     dString := DynamicStrings.InitStringCharStar(cString);
     DynamicStrings.CopyOut(string, dString);
     EXCEPTIONS.RAISE(exSrc, 1, string); 
END Raise;

PROCEDURE Init();
BEGIN
     IF GeneralBase.SDL_Init(0) # 0 THEN
     	  Raise();
     END;
END Init;

PROCEDURE InitSubSystem(flags : SYSTEM.CARDINAL32);
BEGIN
     IF GeneralBase.SDL_InitSubSystem(flags) # 0 THEN
     	  Raise();
     END;
END InitSubSystem;

PROCEDURE Quit();
BEGIN
     GeneralBase.SDL_Quit();
END Quit;

PROCEDURE QuitSubSystem(flags : SYSTEM.CARDINAL32);
BEGIN
     GeneralBase.SDL_QuitSubSystem(flags);
END QuitSubSystem;

PROCEDURE  LinkedVersion() : Version;
VAR version : VersionPtr;
BEGIN
     version := GeneralBase.SDL_Linked_Version();
RETURN version^;
END LinkedVersion;

BEGIN
     EXCEPTIONS.AllocateSource(exSrc);
     Init();
FINALLY
     Quit();
END SKGeneral.

