IMPLEMENTATION MODULE SKVideo;

IMPORT SKGeneral,
       VideoBase;

FROM VideoBase IMPORT RWOpS;

PROCEDURE SetVideoMode(width, height, bitsPerPixel : INTEGER; flags : ModeSettings) : SurfacePtr;
VAR screen         : SurfacePtr;
VAR index          : INTEGER;
BEGIN
     screen := VideoBase.SDL_SetVideoMode(width, height, bitsPerPixel, SYSTEM.CAST(SYSTEM.CARDINAL32, flags));
     IF screen = NIL THEN SKGeneral.Raise(); END;
RETURN screen;
END SetVideoMode;

PROCEDURE LoadBMP(file : ARRAY OF CHAR) : SurfacePtr;
VAR src   : RWOpS;
    BMP   : SurfacePtr;
BEGIN
     src := VideoBase.SDL_RWFromFile(file, 'rb');
     IF src = NIL THEN SKGeneral.Raise(); END;

     BMP := VideoBase.SDL_LoadBMP_RW(src , 1);
     IF BMP = NIL THEN SKGeneral.Raise(); END;
RETURN BMP;
END LoadBMP;

PROCEDURE DisplayFormat(surface : SurfacePtr) : SurfacePtr;
VAR newSurface : SurfacePtr;
BEGIN
     newSurface := VideoBase.SDL_DisplayFormat(surface);
     IF newSurface = NIL THEN SKGeneral.Raise(); END;
RETURN newSurface;
END DisplayFormat;

PROCEDURE FreeSurface(surface : SurfacePtr);
BEGIN
     VideoBase.SDL_FreeSurface(surface);
END FreeSurface;

PROCEDURE LoadDisplayFormatedBMP(file : ARRAY OF CHAR) : SurfacePtr;
VAR loadedSurface    : SurfacePtr;
    convertedSurface : SurfacePtr;
BEGIN
     loadedSurface := LoadBMP(file);  
     convertedSurface := DisplayFormat(loadedSurface); 
     FreeSurface(loadedSurface);
RETURN convertedSurface;
END LoadDisplayFormatedBMP;



PROCEDURE MapRGB(fmt : PixelFormatPtr; r, g, b : SYSTEM.CARDINAL8) : SYSTEM.CARDINAL32;
BEGIN
RETURN VideoBase.SDL_MapRGB(fmt, r, g, b);
END MapRGB;

PROCEDURE SetColorKey(surface : SurfacePtr; flag : ColorKeySettings; key : SYSTEM.CARDINAL32);
VAR error : INTEGER;
BEGIN
     error := VideoBase.SDL_SetColorKey(surface, SYSTEM.CAST(SYSTEM.CARDINAL32, flag), key);
     IF error = -1 THEN SKGeneral.Raise(); END;
END SetColorKey;

PROCEDURE GetClipRect(surface : SurfacePtr) : Rect;
VAR rect : Rect;
BEGIN
     VideoBase.SDL_GetClipRect(surface, rect);
RETURN rect;
END GetClipRect;

PROCEDURE BlitSurface(src : SurfacePtr; srcRect : Rect; dst : SurfacePtr; dstRect : Rect);
VAR error : INTEGER;
BEGIN
     error := VideoBase.SDL_UpperBlit(src, SYSTEM.ADR(srcRect), dst, SYSTEM.ADR(dstRect));
     IF error < 0 THEN SKGeneral.Raise(); END;
END BlitSurface;

PROCEDURE FillRect(dst : SurfacePtr; dstRect : Rect; color : SYSTEM.CARDINAL32);
VAR error : INTEGER;
BEGIN
     error := VideoBase.SDL_FillRect(dst, SYSTEM.ADR(dstRect), color);
     IF error < 0 THEN SKGeneral.Raise(); END;
END FillRect;

PROCEDURE Flip(screen : SurfacePtr);
BEGIN
     VideoBase.SDL_Flip(screen);
END Flip;

BEGIN
     SKGeneral.InitSubSystem(SKGeneral.InitVideo);
END SKVideo.
